// CommandSink.cpp : CCommandSink ̃Cve[V
#include "stdafx.h"
#include "AD_Files.h"
#include "CommandSink.h"

#include "FilesDlg.h"
#include "GenralPage.h"
#include "MySheet.h"
#include "MFilePage.h"
#include "UEEditPage.h"


/////////////////////////////////////////////////////////////////////////////
// CCommandSink


BOOL CCommandSink::SetObjectInfo(ISRAPL *pApl, DWORD dwCookie)
{
    HRESULT hr;

    ASSERT(pApl!=NULL && m_pApl==NULL);
    m_pApl=pApl;

    ASSERT(dwCookie>0 && m_dwCookie==0);
    m_dwCookie=dwCookie;

    hr = AtlAdvise(m_pApl, this->GetUnknown(), DIID__ISRAPLEvents, &m_dwAdvise);
    if(FAILED(hr)){
        m_pApl->Release();
        m_pApl=NULL;
        m_dwCookie=0;
        MessageBox(NULL, "Advise Failed","", MB_OK);
        return FALSE;
    }

	m_dwFlag=AfxGetApp()->GetProfileInt(_T("Files"), _T("Flag"), (F_10|F_11|F_12|F_13));
	m_dwFlag &=0x0000FFFF;
	GetRegistryData(F_1|F_2|F_3|F_4);
		
	return TRUE;
}


void CCommandSink::Unadvise()
{
    if(m_pApl==NULL)
        return;

    HRESULT hr=AtlUnadvise(m_pApl, DIID__ISRAPLEvents, m_dwAdvise);
    if(FAILED(hr)){
        MessageBox(NULL, "Unadvise Failed", "", MB_OK);
    }
    m_pApl->Release();
    m_pApl=NULL;
}





STDMETHODIMP CCommandSink::OnAddinCommand(long lCookie, long lInnerNumber)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	if(m_dwCookie!=(unsigned long)lCookie)
		return S_OK;

	switch(lInnerNumber){
		case	1:
			OnOpenMatchFile();
			break;
		case	2:
			OnEnableEditDir(FALSE);
			break;
		case	3:
			OnEnableEditDir(TRUE);
			break;
		case	4:
			OnEnableEditExt(FALSE);
			break;
		case	5:
			OnEnableEditExt(TRUE);
			break;
		case	6:
			OnFileReadOnly(TRUE);
			break;
		case	7:
			OnFileReadOnly(FALSE);
			break;
		case	8:
			OnDirReadOnly(TRUE);
			break;
		case	9:
			OnDirReadOnly(FALSE);
			break;
		case	10:
			OnSetting();
			break;

	}

	return S_OK;
}

STDMETHODIMP CCommandSink::OnNewInstance()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

	return S_OK;
}

STDMETHODIMP CCommandSink::OnPreOpen()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

	return S_OK;
}


STDMETHODIMP CCommandSink::OnPostOpen()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// OnPostSave̓t@CǍ̌܂菈ʃXbhłÂ
	// 鎞_ŌĂ΂܂B
	// ҏWƂꍇ́AKISREditC^[tF[XIsFormattingNow
	// \bhŁA܂菈̏I҂悤ɂĂB
	// Ał̓[U[̕ҏWƂ֎~邽߁A܂菈̏I
	// ܂Ȃŏs܂B

	ISRFile *pIFile=NULL;
	if(FAILED(m_pApl->CreateFileObject(&pIFile)) || pIFile==NULL){
		MessageBox(NULL, _T("Failed to create ISRFile"), AfxGetAppName(), MB_OK);
		return S_OK; 
	}
	CComBSTR bsSTR;
	pIFile->GetFilePath(&bsSTR);
	CString csFile=bsSTR;
	pIFile->Release();

	list<CString>::iterator p=m_sltUEDir.begin();
	for(; p!=m_sltUEDir.end(); p++){
		if(!_tcsnicmp( (LPCTSTR)*p, (LPCTSTR)csFile, p->GetLength())){
			SetEnableEdit(FALSE);
			return S_OK;
		}
	}	
	int nPos=csFile.ReverseFind(_T('.'));
	if(nPos>0){
		CString csExt=csFile.Mid(nPos+1);
		p=m_sltUEExt.begin();
		for(; p!=m_sltUEExt.end(); p++){
			if(!csExt.CompareNoCase(*p)){
				SetEnableEdit(FALSE);
				return S_OK;
			}
		}
	}

	return S_OK;
}

STDMETHODIMP CCommandSink::OnPreSave()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

	return S_OK;
}



STDMETHODIMP CCommandSink::OnPostSave()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

	return S_OK;
}

STDMETHODIMP CCommandSink::OnCloseInstance()
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

	return S_OK;
}




STDMETHODIMP CCommandSink::OnBroadcastMessage(long lCookie, long lMessage)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

	if(m_dwCookie!=(unsigned long)lCookie)
		return S_OK;

	WORD wNum=HIWORD(lMessage);
	WORD wFlag=LOWORD(lMessage);
	if(wNum!=m_wUnique){
		GetRegistryData(wFlag);
	}

	return S_OK;
}

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////


void CCommandSink::OnOpenMatchFile()
{
	ISRFile *pIFile=NULL;
	if(FAILED(m_pApl->CreateFileObject(&pIFile)) || pIFile==NULL){
		MessageBox(NULL, _T("Failed to create ISRFile"), AfxGetAppName(), MB_OK);
		return; 
	}
	CComBSTR bsSTR;
	pIFile->GetFilePath(&bsSTR);
	CString csFile=bsSTR;

	CStrSet cSS;
	CString csNewFile;
	set<CStrSet>::iterator p;
	int nPos;

	//-----  ΃pX-----------------------------
	cSS.m_csStrA=csFile;
	p=m_sstFile.find(cSS);
	if(p!=m_sstFile.end()){
		DisplayMatchFile(csFile, *p, pIFile);
		pIFile->Release();
		return;
	}

	//-------t@C-------------------------
	nPos=csFile.ReverseFind(_T('\\'));
	if(nPos>=0) {
		cSS.m_csStrA=csFile.Mid(nPos+1);
		p=m_sstFile.find(cSS);
		if(p!=m_sstFile.end()){
			DisplayMatchFile(csFile, *p, pIFile);
			pIFile->Release();
			return;
		}
	}

	// --------gq------------------------------
	nPos=csFile.ReverseFind(_T('.'));
	if(nPos>=0){
		cSS.m_csStrA=csFile.Mid(nPos+1);
		p=m_sstExt.find(cSS);
		if(p!=m_sstExt.end()){
			DisplayMatchFile(csFile, *p, pIFile);
			pIFile->Release();
			return;
		}
	}

	//-------------------------------------------------
	
	ISREdit *pIEdit=NULL;
	if(FAILED(m_pApl->CreateEditObject(&pIEdit)) || pIEdit==NULL){
		pIFile->Release();
		return; 
	}
	bsSTR=_T("Ήt@CEgq͐ݒ肳Ă܂B");
	pIEdit->SetStatusBarText(bsSTR);
	pIEdit->Release();
	pIFile->Release();

}


void FileExist(LPCTSTR lpFile, list<CString>& ltF)
{

	WIN32_FIND_DATA fData;
	CString csTmp;
	HANDLE hdl=FindFirstFile(lpFile, &fData);
	if(hdl!=INVALID_HANDLE_VALUE){
		do {
			if(!(fData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)){
				csTmp=fData.cFileName;
				ltF.push_back(csTmp);
			}
		}while(FindNextFile(hdl, &fData));
	}
	FindClose(hdl);
}




void CCommandSink::DisplayMatchFile(CString& csFile,  CStrSet& cSS, ISRFile *pIFile)
{
	int nPos;
	CString csDir=_T("");
	CString csNewFile;
	
	if((cSS.m_dwMFlag & FLAG_MASK_A)==1){ // fBNg
		nPos=csFile.ReverseFind(_T('\\'));
		if(nPos<0)
			csNewFile=csFile;
		else {
			csNewFile=csFile.Left(nPos+1);
			csDir=csNewFile;
		}
		csNewFile +=cSS.m_csStrB;
	}
	else if((cSS.m_dwMFlag & FLAG_MASK_A)==2){ // ΃pX
		csNewFile=cSS.m_csStrB;
	}
	else {		// gq
		nPos=csFile.ReverseFind(_T('.'));
		if(nPos<0)
			csNewFile=csFile + _T(".");
		else
			csNewFile=csFile.Left(nPos+1);
		csNewFile +=cSS.m_csStrB;
	}

	CComBSTR bsSTR;
	list<CString> ltF;
	list<CString>::iterator p;
	FileExist(csNewFile, ltF);

	if(ltF.size()==0){
		ISREdit *pIEdit=NULL;
		if(FAILED(m_pApl->CreateEditObject(&pIEdit)) || pIEdit==NULL){
			return; 
		}
		bsSTR=_T("Ήt@C܂B");
		pIEdit->SetStatusBarText(bsSTR);
		pIEdit->Release();
		return;
	}
	
	if(csDir.IsEmpty()){
		nPos=csFile.ReverseFind(_T('\\'));
		if(nPos>=0)
			csDir=csFile.Left(nPos+1);		
	}
	csNewFile=csDir;
	if(ltF.size()>1){
		FilesDlg dlg;
		ltF.sort();
		dlg.SetListPointer(&ltF);
		if(IDCANCEL==dlg.DoModal())
			return;
		csNewFile +=dlg.m_csSel;
	}
	else {	
		p=ltF.begin();
		csNewFile += *p;	
	}

	bsSTR=csNewFile;
	long lhwnd;
	VARIANT_BOOL bResult;
	pIFile->IsAlreadyOpened(bsSTR, &lhwnd, &bResult);
	if(bResult)
		SetForegroundWindow((HWND)lhwnd);
	else
		pIFile->OpenFile(bsSTR, &bResult);

}



///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////



void CCommandSink::OnEnableEditDir(BOOL bEnable)
{
	CString csFile;
	if(!GetFileName(csFile))
		return;

	int nPos=csFile.ReverseFind(_T('\\'));
	if(nPos<0) return;

	CString csDir=csFile.Left(nPos+1);
	
	SetEnableEdit(bEnable);
	list<CString>::iterator p=m_sltUEDir.begin();
	if(!bEnable) {
		for( ; p!=m_sltUEDir.end(); p++){
			if(!csDir.CompareNoCase(*p)){
				break;
			}
		}
		if(p!=m_sltUEDir.end()) return;
		m_sltUEDir.push_back(csDir);

	}
	else {
		for(; p!=m_sltUEDir.end(); p++) {
			if(!_tcsnicmp( (LPCTSTR)*p, (LPCTSTR)csFile, p->GetLength())){
				break;
			}
		}
		if(p==m_sltUEDir.end()) return;
		m_sltUEDir.erase(p);
	}
	WriteRegistryData(F_1);

}

void CCommandSink::OnEnableEditExt(BOOL bEnable)
{
	CString csFile;
	if(!GetFileName(csFile))
		return;

	int nPos=csFile.ReverseFind(_T('.'));
	if(nPos<0) return;

	CString csExt=csFile.Mid(nPos+1);
	
	SetEnableEdit(bEnable);
	list<CString>::iterator p=m_sltUEExt.begin();
	for( ; p!=m_sltUEExt.end(); p++){
		if(!csExt.CompareNoCase(*p)){
			break;
		}
	}
	if(!bEnable) {
		if(p!=m_sltUEExt.end()) return;
		m_sltUEExt.push_back(csExt);
	}	
	else {
		if(p==m_sltUEExt.end()) return;
		m_sltUEExt.erase(p);
	}
	WriteRegistryData(F_2);
}


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void CCommandSink::OnFileReadOnly(BOOL bReadOnly)
{
	CString csFile;
	if(!GetFileName(csFile))
		return;

	CString csMsg=_T("t@C̑ύXɎs܂B");
	DWORD dwAttr=GetFileAttributes(csFile);
	if(dwAttr==0xFFFFFFFF){
		MessageBox(NULL, csMsg, AfxGetAppName(), MB_OK);
		return;
	}

	(bReadOnly) ? (dwAttr |=FILE_ATTRIBUTE_READONLY) : (dwAttr &=~FILE_ATTRIBUTE_READONLY);
	
	if(!SetFileAttributes(csFile, dwAttr)){
		MessageBox(NULL, csMsg, AfxGetAppName(), MB_OK);
		return;
	}
				
	SetEnableEdit(!bReadOnly);

}


void ExecAttrChange( DWORD dwBit, BOOL bOn, LPCTSTR lpDir, int nSubDir)
{
	CString csFName=lpDir;
	csFName +="\\*";
	
	WIN32_FIND_DATA fData;
	HANDLE hdl=FindFirstFile(csFName, &fData);
	if(hdl!=INVALID_HANDLE_VALUE){
		do {
			if(!strcmp(fData.cFileName, ".") || !strcmp(fData.cFileName, ".."))
				continue; 
		
			if(fData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY){
				if(nSubDir==0){
					nSubDir=MessageBox(NULL, _T("TufBNg̃t@C܂H"), AfxGetAppName(), MB_YESNOCANCEL);
					if(nSubDir==IDCANCEL){
						CloseHandle(hdl);
						return;
					}
				}
				if(nSubDir==IDYES) {
					CString csDir=lpDir;
					csDir +=_T("\\");
					csDir +=fData.cFileName;
					ExecAttrChange(dwBit, bOn, csDir, nSubDir);
				}
			}
			else {
				CString csFile=lpDir;	
				csFile +=_T("\\");
				csFile +=fData.cFileName;
				(bOn) ? (fData.dwFileAttributes |=dwBit) : (fData.dwFileAttributes &=~dwBit);
				SetFileAttributes(csFile, fData.dwFileAttributes);
			}	
		}while(FindNextFile(hdl,&fData));
	}
	CloseHandle(hdl);
}



void CCommandSink::OnDirReadOnly(BOOL bReadOnly)
{
	CString csFile;
	if(!GetFileName(csFile))
		return;

	int nPos=csFile.ReverseFind(_T('\\'));
	if(nPos<0) return;

	CString csDir=csFile.Left(nPos);
	
	CString csMsg;
	if(!bReadOnly)
		csMsg=_T("fBNg̑St@C̏݋֎~܂B낵łH");
	else 
		csMsg=_T("fBNg̑St@Cɏ݋֎~ݒ肵܂B낵łH");

	if(IDCANCEL==MessageBox(NULL, csMsg, AfxGetAppName(), MB_OK))
		return;


	SetEnableEdit(!bReadOnly);
	ExecAttrChange(FILE_ATTRIBUTE_READONLY, bReadOnly, csDir, 0);
	MessageBox(NULL, _T("܂B"), AfxGetAppName(), MB_OK);

}

///////////////////////////////////////////////////////////////////////////////



void CCommandSink::OnSetting()
{
	long lhMain;
	m_pApl->GetMainWindowHandle(&lhMain);
	if(lhMain==0) return;

	CWnd wndParent;
	if(!wndParent.Attach((HWND)lhMain)){
		TRACE("Parent Window Attach Failed");
		return;
	}

	CMySheet Sheet("AD_Files.Dll̐ݒ", &wndParent);
	
	CGeneralPage gnPage;
	CMFilePage	mfPageA(IDS_MFILES_A);
	CMFilePage	mfPageB(IDS_MFILES_B);
	CUEEditPage uePage;
	
	gnPage.SetSinkPointer(this);
	mfPageA.SetPageType(1, this);
	mfPageB.SetPageType(2, this);
	uePage.SetSinkPointer(this);

	Sheet.AddPage(&gnPage);
	Sheet.AddPage(&mfPageA);
	Sheet.AddPage(&mfPageB);
	Sheet.AddPage(&uePage);

	WORD wFlag=0;
	if(Sheet.DoModal()==IDOK){
		DWORD dwDiff=(m_dwFlag ^ gnPage.m_dwFlag);
		if(dwDiff){
			m_dwFlag=gnPage.m_dwFlag;
			AfxGetApp()->WriteProfileInt(_T("Files"), _T("Flag"), (m_dwFlag & 0x0000FFFF));
			MessageBox(NULL, _T("c[o[ɊւݒύX͎ɋNCX^XLɂȂ܂B"), 
				_T("AD_FilesɊւݒ"), MB_OK);	
		}
		if(!IsSameStringList(&m_sltUEDir, &uePage.m_sltDir)){
			wFlag |=F_1;
			m_sltUEDir.clear();
			copy(uePage.m_sltDir.begin(), uePage.m_sltDir.end(),
					inserter(m_sltUEDir, m_sltUEDir.begin()));
		}
		if(!IsSameStringList(&m_sltUEExt, &uePage.m_sltExt)){
			wFlag |=F_2;
			m_sltUEExt.clear();
			copy(uePage.m_sltExt.begin(), uePage.m_sltExt.end(),
					inserter(m_sltUEExt, m_sltUEExt.begin()));
		}
		if(!IsSameSet(&m_sstExt, &mfPageA.m_sstST) ) {
			wFlag |=F_3;
			m_sstExt.clear();
			copy(mfPageA.m_sstST.begin(), mfPageA.m_sstST.end(),
						inserter(m_sstExt, m_sstExt.begin()));
		}
		if(!IsSameSet(&m_sstFile, &mfPageB.m_sstST) ) {
			wFlag |=F_4;
			m_sstFile.clear();
			copy(mfPageB.m_sstST.begin(), mfPageB.m_sstST.end(),
						inserter(m_sstFile, m_sstFile.begin()));

		}
	}
	wndParent.Detach();

	if(wFlag==0) return;

	// ύXWXgɏÃCX^X֕ύXu[hLXg܂B
	WriteRegistryData(wFlag);
	if(m_wUnique==0){ // xǂ݂邽߁AMCX^X肵܂B
		GetUniqueWord();
	}
	LONG lMsg=MAKELONG( wFlag, m_wUnique);
	m_pApl->BroadcastMessage(m_dwCookie, lMsg);


}


///////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

BOOL CCommandSink::GetFileName(CString &csFile)
{
	ISRFile *pIFile=NULL;
	if(FAILED(m_pApl->CreateFileObject(&pIFile)) || pIFile==NULL){
		MessageBox(NULL, _T("Failed to create ISRFile"), AfxGetAppName(), MB_OK);
		return  FALSE; 
	}
	CComBSTR bsSTR;
	pIFile->GetFilePath(&bsSTR);
	csFile=bsSTR;
	pIFile->Release();
	return TRUE;
}


void CCommandSink::SetEnableEdit(BOOL bEnable)
{
	ISREdit *pIEdit=NULL;
	if(FAILED(m_pApl->CreateEditObject(&pIEdit)) || pIEdit==NULL){
		MessageBox(NULL, _T("Failed to create ISREdit"), AfxGetAppName(), MB_OK);
		return; 
	}
	pIEdit->SetEnableEdit(bEnable);
	pIEdit->Release();
}


////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

template <class T>
BOOL WriteBinaryData(HKEY hkey, T& sltLT, LPCTSTR lpKey)
{
	CMemFile mF;
	CArchive ar(&mF, CArchive::store);

	
	DWORD dwListSize=sltLT.size();
	ar << dwListSize;
	T::iterator p=sltLT.begin();
	for( p; p!=sltLT.end(); p++)
		ar << *p;
	ar.Flush();
	
	DWORD dwSize=mF.GetLength();
	BYTE *pData=new BYTE[dwSize];
	mF.SeekToBegin();
	mF.Read(pData, dwSize);
	ar.Close();
	mF.Close();
	
	BOOL bRtn=TRUE;
	if(ERROR_SUCCESS!=RegSetValueEx(hkey, lpKey, NULL, REG_BINARY,pData, dwSize)){
		MessageBox(NULL, _T("Failed to write registry"), AfxGetAppName(), MB_OK);
		bRtn=FALSE;
	}
	delete [] pData;
	
	return bRtn;
}




void CCommandSink::WriteRegistryData(WORD wFlag)
{
	CRegKey rKeyBase1, rKeyBase2;
	TCHAR szBuff[300];
	wsprintf(szBuff, "Software\\Kazusoft\\%s", DATA_KEY);
	if(ERROR_SUCCESS!=rKeyBase1.Create(HKEY_CURRENT_USER, szBuff)){
		MessageBox(NULL, _T("Failed to create registry key 1"), AfxGetAppName(), MB_OK);
		return;
	}
	if(ERROR_SUCCESS!=rKeyBase2.Create(rKeyBase1.m_hKey, _T("Files"))){
		MessageBox(NULL, _T("Failed to create registry key 2"), AfxGetAppName(), MB_OK);
		rKeyBase1.Close();
		return;
	}
	rKeyBase1.Close();

	if(wFlag & F_1 && !WriteBinaryData(rKeyBase2.m_hKey, m_sltUEDir, _T("UEDir"))){		
		rKeyBase2.Close();
		return;
	}
	
	if(wFlag & F_2 && !WriteBinaryData(rKeyBase2.m_hKey, m_sltUEExt, _T("UEExt"))){
		rKeyBase2.Close();
		return;
	}

	if(wFlag & F_3 && !WriteBinaryData(rKeyBase2.m_hKey, m_sstExt, _T("ExtSet"))){
		rKeyBase2.Close();
		return;
	}
	
	if(wFlag & F_4 && !WriteBinaryData(rKeyBase2.m_hKey, m_sstFile, _T("FileSet"))){
		rKeyBase2.Close();
		return;
	}
	
	rKeyBase2.Close();
	return;


}


template <class T>
void GetBinaryDataA(HKEY hKey, T& sltLT,  LPCTSTR lpKey)
{
	DWORD dwType, dwSize, dwSetSize;
	int i;
	CString csTmp;
	LONG lRes;

	lRes = RegQueryValueEx(hKey, lpKey, NULL, &dwType,NULL, &dwSize);
	if(lRes!=ERROR_SUCCESS || dwType!=REG_BINARY) {
		dwSize=0;
	}
	if(dwSize>0){
		BYTE *pData =new BYTE[dwSize];
		lRes=RegQueryValueEx(hKey, lpKey, NULL, &dwType, pData,&dwSize);
		if(lRes==ERROR_SUCCESS){
			CMemFile mF;
			mF.Write(pData , dwSize);
			mF.SeekToBegin();
			CArchive ar(&mF, CArchive::load);
			ar >> dwSetSize;
			for(i=0; i<dwSetSize; i++) 	{
				ar >> csTmp;
				sltLT.push_back(csTmp);
			}
		}
		delete [] pData;
	}

}

template <class T>
void GetBinaryDataB(HKEY hKey, T& sltLT, int nHow,  LPCTSTR lpKey)
{
	DWORD dwType, dwSize, dwSetSize;
	int i;
	LONG lRes;
	CStrSet cSS;

	lRes = RegQueryValueEx(hKey, lpKey, NULL, &dwType,NULL, &dwSize);
	if(lRes!=ERROR_SUCCESS || dwType!=REG_BINARY) {
		dwSize=0;
		if(nHow==11){
			cSS.m_csStrA=_T("cpp"); cSS.m_csStrB=_T("h"); cSS.m_dwMFlag=0;
			sltLT.insert(cSS);
			cSS.m_csStrA=_T("c"); cSS.m_csStrB=_T("h"); cSS.m_dwMFlag=0;
			sltLT.insert(cSS);
			cSS.m_csStrA=_T("h"); cSS.m_csStrB=_T("cpp"); cSS.m_dwMFlag=0;
			sltLT.insert(cSS);
			cSS.m_csStrA=_T("y"); cSS.m_csStrB=_T("l"); cSS.m_dwMFlag=0;
			sltLT.insert(cSS);
			cSS.m_csStrA=_T("l"); cSS.m_csStrB=_T("y"); cSS.m_dwMFlag=0;
			sltLT.insert(cSS);
			cSS.m_csStrA=_T("rc"); cSS.m_csStrB=_T("resource.h"); cSS.m_dwMFlag=F_1;
			sltLT.insert(cSS);
		}
		else if(nHow==12) {
			cSS.m_csStrA=_T("resource.h"); cSS.m_csStrB=_T("*.rc"); cSS.m_dwMFlag=F_1;
			sltLT.insert(cSS);
		}
	}
	if(dwSize>0){
		BYTE *pData =new BYTE[dwSize];
		lRes=RegQueryValueEx(hKey, lpKey, NULL, &dwType, pData,&dwSize);
		if(lRes==ERROR_SUCCESS){
			CMemFile mF;
			mF.Write(pData , dwSize);
			mF.SeekToBegin();
			CArchive ar(&mF, CArchive::load);
			ar >> dwSetSize;
			for(i=0; i<dwSetSize; i++) 	{
				ar >> cSS;
				sltLT.insert(cSS);
			}
		}
		delete [] pData;
	}

}





void CCommandSink::GetRegistryData(WORD wFlag)
{
	CRegKey rKeyBase;
	TCHAR szBuff[300];
	wsprintf(szBuff, "Software\\Kazusoft\\%s\\Files", DATA_KEY);

	if(ERROR_SUCCESS!=rKeyBase.Open(HKEY_CURRENT_USER, szBuff))
		return;
	
	if(wFlag & F_1){
		m_sltUEDir.clear();
		GetBinaryDataA(rKeyBase.m_hKey, m_sltUEDir, _T("UEDir"));
	}
	
	if(wFlag & F_2) {
		m_sltUEExt.clear();
		GetBinaryDataA(rKeyBase.m_hKey, m_sltUEDir,  _T("UEExt"));
	}
	
	if(wFlag & F_3){
		m_sstExt.clear();
		GetBinaryDataB(rKeyBase.m_hKey, m_sstExt, 11, _T("ExtSet"));
	}

	if(wFlag & F_4){
		m_sstFile.clear();
		GetBinaryDataB(rKeyBase.m_hKey, m_sstFile, 12, _T("FileSet"));
	}

	rKeyBase.Close();
}


void CCommandSink::GetUniqueWord()
{
	if(m_wUnique!=0) return;

	long lhwnd;
	m_pApl->GetMainWindowHandle(&lhwnd);
	m_wUnique =0x0000FFFF & lhwnd;

}



